using FluentValidation;
using CMSMicroservice.Protobuf.Protos.UserOrder;
namespace CMSMicroservice.Protobuf.Validator.UserOrder;

public class SubmitShopBuyOrderRequestValidator : AbstractValidator<SubmitShopBuyOrderRequest>
{
    public SubmitShopBuyOrderRequestValidator()
    {
        RuleFor(model => model.TotalAmount)
            .NotNull();
        RuleFor(model => model.UserId)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<SubmitShopBuyOrderRequest>.CreateWithOptions((SubmitShopBuyOrderRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
